swagger: '2.0'
info:
  description: Configuration for Af report for ICA Session resource.
  version: 'v2'
  title: related_ica_session
host: 'adm.cloud.com'
schemes:
 - https
# tags are used for organizing operations
tags:
  - name: related_ica_session
    description: Af report for ICA Session
consumes:
  - application/json
produces:
  - application/json
securityDefinitions:
  UserSecurity:
    type: basic
security:
  - UserSecurity: []
parameters:
  authParam:
      in: header
      name: Authorization
      type: string
      required: true
      description: Session Id for authentication.Should be mentioned in the format CwsAuth bearer=sessionIdValue
  cloudParam:
      in: header
      name: isCloud
      type: string
      required: true
      description: set the value to true in case of Cloud services, false for on-prem deployment
paths:
  /massvc/{customerid}/nitro/v2/config/related_ica_session:
    get:
      tags:
        - related_ica_session
      summary: GET all related_ica_session
      operationId: getall_related_ica_session
      description: Af Report for ICA User.
      consumes:
        - application/json
      produces:
        - application/json
      parameters:
        - in: path
          name: customerid
          type: string
          required: true
          description: Customer Id of the user
        - in: header
          name: Authorization
          type: string
          required: true
          description: Session Id for authentication.Should be mentioned in the format CwsAuth bearer=sessionIdValue
        - in: header
          name: isCloud
          type: string
          required: true
          description: set the value to true in case of Cloud services, false for on-prem deployment
        - in: query
          name: filter
          type: string
          required: false
          description: "Use this query-parameter to get the filtered set of vm_device resources configured on the system. You can set a filter on any property of the resource.Example:  property-name1:property-value1 "
        - in: query
          name: pagesize
          type: integer
          required: false
          description: Use this query-parameter to get the related_ica_session resources in chunks.To be used along with pageno query parameter.
        - in: query
          name: pageno
          type: integer
          required: false
          description: Use this query-parameter to get the related_ica_session resources in chunks.To be used along with pagesize query parameter.
        - in: query
          name: count
          type: string
          required: false
          description: Use this query-parameter to get the count of related_ica_session resources.
          enum:
            - yes
      responses:
        200:
          description:  for related_ica_session
          schema: 
              $ref: '#/definitions/getrelated_ica_sessionsResponse'
        400:
          description: Bad input parameter
          schema: 
              $ref: '#/definitions/Error'
        401:
          description: Failed Authentication
          schema: 
              $ref: '#/definitions/Error'
        403:
          description: Unauthorized
          schema: 
              $ref: '#/definitions/Error'
        404:
          description: Item not found
          schema: 
              $ref: '#/definitions/Error'
        409:
          description: Resource Conflict
          schema: 
              $ref: '#/definitions/Error'
        500:
          description: Server Error
          schema: 
              $ref: '#/definitions/Error'
        504:
          description: Gateway Timeout
          schema: 
              $ref: '#/definitions/Error'

definitions:
  getrelated_ica_sessionResponse:
    type: object
    required:
      - related_ica_session
    properties:
      related_ica_session:
        $ref: '#/definitions/related_ica_session'
    title: getrelated_ica_sessionResponse
    example:
      related_ica_session:
        serverside_packet_retransmits: "1"
        user_type: "0"
        is_msi: "1"
        ip_block_name: "ip block name"
        launch_duration: "10"
        latitude: "12.9716"
        longitude: "77.5946"
        region_code: "KA"
        host_delay: "10"
        region: "Karnataka"
        total_bytes: "5032.2"
        is_active: "1"
        client_ip_address: "1.1.1.1"
        pn_agent_version: "0"
        client_latency: "10"
        client_side_ns_delay: "10"
        server_side_ns_delay: "10"
        session_reconnect: "1"
        application_enumeration_duration: "10"
        serverside_rto: "0"
        duration_summary_bandwidth: "3051.53"
        country: "INDIA"
        clientside_packet_retransmits: "1"
        server_ip_address: "1.1.1.1"
        rpt_sample_time: "1548293932"
        clientside_0_win: "0"
        bandwidth: "502.3"
        session_setup_time: "1548293932"
        clientside_rto: "0"
        ica_app_name: "test_ica_app"
        session_rtt: "0"
        clientside_cb: "0"
        client_version: "14.1.12"
        ica_user_name: "test_user"
        __count: "10"
        country_code: "IN"
        state: "UP"
        client_type: "Citrix Windows client"
        euem: "0"
        l7_clientside_latency: "0"
        server_jitter: "0"
        id: "00000000-0000-375c-0000-000400000004"
        client_jitter: "0"
        server_latency: "0"
        is_multi_hop: "1"
        serverside_0_win: "0"
        serverside_cb: "0"
        session_type: "0"
        acr_count: "10"
        sr_reconnect_count: "10"
        selected_time_total_byte: "100.23"
        client_srtt: "10"
        edt_type: "0"
        ica_device_ip_address: "1.1.1.1"
        city: "Bangalore"
        receiver_version: "1.1.1"
        up_time: "0"
        client_tx_bytes: "-1"
        session_setup_time_local: "154233212"
        client_rx_bytes: "-1"
        server_srtt: "10"
        session_end_time: "1548293932"
        l7_serverside_latency: "0"

  getrelated_ica_sessionsResponse:
    type: object
    required:
      - related_ica_session
    properties:
      related_ica_session:
        type: array
        items:
          $ref: '#/definitions/related_ica_session'
    title: getrelated_ica_sessionsResponse
    example:
      related_ica_session:
        serverside_packet_retransmits: "1"
        user_type: "0"
        is_msi: "1"
        ip_block_name: "ip block name"
        launch_duration: "10"
        latitude: "12.9716"
        longitude: "77.5946"
        region_code: "KA"
        host_delay: "10"
        region: "Karnataka"
        total_bytes: "5032.2"
        is_active: "1"
        client_ip_address: "1.1.1.1"
        pn_agent_version: "0"
        client_latency: "10"
        client_side_ns_delay: "10"
        server_side_ns_delay: "10"
        session_reconnect: "1"
        application_enumeration_duration: "10"
        serverside_rto: "0"
        duration_summary_bandwidth: "3051.53"
        country: "INDIA"
        clientside_packet_retransmits: "1"
        server_ip_address: "1.1.1.1"
        rpt_sample_time: "1548293932"
        clientside_0_win: "0"
        bandwidth: "502.3"
        session_setup_time: "1548293932"
        clientside_rto: "0"
        ica_app_name: "test_ica_app"
        session_rtt: "0"
        clientside_cb: "0"
        client_version: "14.1.12"
        ica_user_name: "test_user"
        __count: "10"
        country_code: "IN"
        state: "UP"
        client_type: "Citrix Windows client"
        euem: "0"
        l7_clientside_latency: "0"
        server_jitter: "0"
        id: "00000000-0000-375c-0000-000400000004"
        client_jitter: "0"
        server_latency: "0"
        is_multi_hop: "1"
        serverside_0_win: "0"
        serverside_cb: "0"
        session_type: "0"
        acr_count: "10"
        sr_reconnect_count: "10"
        selected_time_total_byte: "100.23"
        client_srtt: "10"
        edt_type: "0"
        ica_device_ip_address: "1.1.1.1"
        city: "Bangalore"
        receiver_version: "1.1.1"
        up_time: "0"
        client_tx_bytes: "-1"
        session_setup_time_local: "154233212"
        client_rx_bytes: "-1"
        server_srtt: "10"
        session_end_time: "1548293932"
        l7_serverside_latency: "0"

  related_ica_session_readwrite:
    type: object
    properties:
      serverside_packet_retransmits:
        description: "Server side packet retransmits."
        type: number
        format: double
      user_type:
        description: "User Access Type"
        type: string
        format: string
        minLength: 1
        maxLength: 128
      is_msi:
        description: "If Session is MSI or not"
        type: number
        format: double
      ip_block_name:
        description: "ip_block_name"
        type: string
        format: string
      launch_duration:
        description: "ica session launch duration."
        type: number
        format: double
      latitude:
        description: "latitude"
        type: number
        format: double
      longitude:
        description: "longitude"
        type: number
        format: double
      region_code:
        description: "region_code"
        type: string
        format: string
      host_delay:
        description: "Server induced delay."
        type: number
        format: double
      region:
        description: "region"
        type: string
        format: string
      total_bytes:
        description: "Total bytes accounted by this URL in sampled timeframe."
        type: number
        format: double
      is_active:
        description: "Is Active."
        type: number
        format: double
      pn_agent_version:
        description: "Name of ICA session pn agent version"
        type: string
        format: string
        minLength: 1
        maxLength: 128
      client_latency:
        description: "ica session client latency."
        type: number
        format: double
      client_side_ns_delay:
        description: "Client to Server NetScaler delay."
        type: number
        format: double
      server_side_ns_delay:
        description: "Server to Client NetScaler delay."
        type: number
        format: double
      session_reconnect:
        description: "Session reconnect."
        type: number
        format: double
      application_enumeration_duration:
        description: "Time taken for app enumeration to launch."
        type: number
        format: double
      serverside_rto:
        description: "serverside rto."
        type: number
        format: double
      duration_summary_bandwidth:
        description: "Avg Bandwidth for duration summary."
        type: number
        format: double
      country:
        description: "country"
        type: string
        format: string
      clientside_packet_retransmits:
        description: "Client side packet retransmits."
        type: number
        format: double
      rpt_sample_time:
        description: "Report Sample time."
        type: number
        format: double
      clientside_0_win:
        description: "Client side 0 window count."
        type: number
        format: double
      bandwidth:
        description: "Avg Bandwidth."
        type: number
        format: double
      session_setup_time:
        description: "ICA Session setup time."
        type: number
        format: double
      clientside_rto:
        description: "clientside rto."
        type: number
        format: double
      session_rtt:
        description: "ICA Session rtt."
        type: number
        format: double
      clientside_cb:
        description: "clientside cb"
        type: number
        format: double
      client_version:
        description: "Client Version"
        type: string
        format: string
        maxLength: 1024
      __count:
        description: "count."
        type: number
        format: double
      country_code:
        description: "country_code"
        type: string
        format: string
      state:
        description: "ICA Session state."
        type: string
        format: string
      client_type:
        description: "Client Type"
        type: string
        format: string
        minLength: 1
        maxLength: 128
      euem:
        description: "EUEM."
        type: number
        format: double
      l7_clientside_latency:
        description: "L7 clientside latency"
        type: number
        format: double
      server_jitter:
        description: "ICA User server jitter."
        type: number
        format: double
      id:
        description: "Id is ICA Session ID"
        type: string
        format: uuid
        minLength: 1
        maxLength: 64
      client_jitter:
        description: "ICA User client jitter."
        type: number
        format: double
      server_latency:
        description: "ica session server latency."
        type: number
        format: double
      is_multi_hop:
        description: "Is Multi hop."
        type: number
        format: double
      serverside_0_win:
        description: "server side 0 window count."
        type: number
        format: double
      serverside_cb:
        description: "serverside cb"
        type: number
        format: double
      session_type:
        description: "Session Type"
        type: number
        format: double
      acr_count:
        description: "Session Reliability ACR Reconnect count"
        type: number
        format: double
      sr_reconnect_count:
        description: "Session Reliability Reconnect count"
        type: number
        format: double
      selected_time_total_byte:
        description: "Total bytes accounted by this URL in sampled timeframe."
        type: number
        format: double
      client_srtt:
        description: "client Smothen RTT."
        type: number
        format: double
      edt_type:
        description: "edt_type"
        type: string
        format: string
      city:
        description: "city"
        type: string
        format: string
      receiver_version:
        description: "Name of ICA session receiver version"
        type: string
        format: string
        minLength: 1
        maxLength: 128
      up_time:
        description: "ica session up time."
        type: number
        format: double
      client_tx_bytes:
        description: "Client Side Tx bytes."
        type: number
        format: double
      session_setup_time_local:
        description: "ICA Session setup time in local timezone."
        type: number
        format: double
      client_rx_bytes:
        description: "Client Side Rx bytes."
        type: number
        format: double
      server_srtt:
        description: "server Smothen RTT."
        type: number
        format: double
      session_end_time:
        description: "ICA Session end time."
        type: number
        format: double
      l7_serverside_latency:
        description: "L7 serverside latency"
        type: number
        format: double

  related_ica_session:
    allOf:
      - $ref: '#/definitions/related_ica_session_readwrite'

  Error:
    properties:
      errorcode:
        type: number
        format: int32
        example: 1001
      errormessage:
        type: string
        format: string
        example: "id cannot be found"
